Adding EaltEdge CLI Command For Deployment 28/3428/1
authorabhijit_onap <abhijit.das.gupta@huawei.com>
Wed, 13 May 2020 03:00:39 +0000 (08:30 +0530)
committerabhijit_onap <abhijit.das.gupta@huawei.com>
Wed, 13 May 2020 03:00:39 +0000 (08:30 +0530)
Commands Added for Installation and Uninstallation
of EALTEdge Environment.

Signed-off-by: abhijit_onap <abhijit.das.gupta@huawei.com>
Change-Id: I2417e78f03908da2ed872462da57d2ffb0606981

21 files changed:
ocd/cli/ealt/build_cli.sh [new file with mode: 0644]
ocd/cli/ealt/cmd/clean.go [new file with mode: 0644]
ocd/cli/ealt/cmd/clean/all.go [new file with mode: 0644]
ocd/cli/ealt/cmd/clean/edge.go [new file with mode: 0644]
ocd/cli/ealt/cmd/clean/infra.go [new file with mode: 0644]
ocd/cli/ealt/cmd/clean/k3s.go [new file with mode: 0644]
ocd/cli/ealt/cmd/clean/k8s.go [new file with mode: 0644]
ocd/cli/ealt/cmd/clean/mecm.go [new file with mode: 0644]
ocd/cli/ealt/cmd/init.go [new file with mode: 0644]
ocd/cli/ealt/cmd/init/all.go [new file with mode: 0644]
ocd/cli/ealt/cmd/init/edge.go [new file with mode: 0644]
ocd/cli/ealt/cmd/init/infra.go [new file with mode: 0644]
ocd/cli/ealt/cmd/init/k3s.go [new file with mode: 0644]
ocd/cli/ealt/cmd/init/k8s.go [new file with mode: 0644]
ocd/cli/ealt/cmd/init/mecm.go [new file with mode: 0644]
ocd/cli/ealt/cmd/root.go [new file with mode: 0644]
ocd/cli/ealt/cmd/setup/common.go [new file with mode: 0644]
ocd/cli/ealt/cmd/setup/install.go [new file with mode: 0644]
ocd/cli/ealt/go.mod [new file with mode: 0644]
ocd/cli/ealt/go.sum [new file with mode: 0644]
ocd/cli/ealt/main.go [new file with mode: 0644]

diff --git a/ocd/cli/ealt/build_cli.sh b/ocd/cli/ealt/build_cli.sh
new file mode 100644 (file)
index 0000000..29c52d8
--- /dev/null
@@ -0,0 +1,20 @@
+#!/bin/bash
+
+CLIDIR=$PWD
+
+export GOROOT=/usr/local/go
+export GOPATH=$HOME/go
+export PATH=$GOPATH/bin:$GOROOT/bin:$PATH
+
+go version
+if [ $? -ne 0 ]; then
+
+  cd /tmp/
+  wget -N https://dl.google.com/go/go1.14.linux-amd64.tar.gz
+  tar -xvf go1.13.3.linux-amd64.tar.gz
+  mv go /usr/local
+fi
+
+cd $CLIDIR
+
+go install
diff --git a/ocd/cli/ealt/cmd/clean.go b/ocd/cli/ealt/cmd/clean.go
new file mode 100644 (file)
index 0000000..daa96d8
--- /dev/null
@@ -0,0 +1,47 @@
+/*
+Copyright 2020 Huawei Technologies Co., Ltd.
+
+Licensed under the Apache License, Version 2.0 (the "License");
+you may not use this file except in compliance with the License.
+You may obtain a copy of the License at
+
+    http://www.apache.org/licenses/LICENSE-2.0
+
+Unless required by applicable law or agreed to in writing, software
+distributed under the License is distributed on an "AS IS" BASIS,
+WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+See the License for the specific language governing permissions and
+limitations under the License.
+*/
+package cmd
+
+import (
+
+       cleancmds "ealt/cmd/clean"
+       "github.com/spf13/cobra"
+)
+
+// cleanCmd represents the clean command
+var cleanCmd = &cobra.Command{
+       Use:   "clean",
+       Short: "To uninstall ealt environment or specific component or node.",
+       Long: `To uninstall ealt environment or specific component or node.`,
+}
+
+func init() {
+       cleanCmd.AddCommand(cleancmds.NewAllCommand())
+       //ealt init infra
+       cleanCmd.AddCommand(cleancmds.NewInfraCommand())
+       //ealt init manager
+       cleanCmd.AddCommand(cleancmds.NewMecmCommand())
+       //ealt init edge
+       cleanCmd.AddCommand(cleancmds.NewEdgeCommand())
+       //ealt init k8s
+       cleanCmd.AddCommand(cleancmds.NewK8SCommand())
+       //ealt init k3s
+       cleanCmd.AddCommand(cleancmds.NewK3SCommand())
+
+       //Add init subcommand to root command.
+       rootCmd.AddCommand(cleanCmd)
+
+}
\ No newline at end of file
diff --git a/ocd/cli/ealt/cmd/clean/all.go b/ocd/cli/ealt/cmd/clean/all.go
new file mode 100644 (file)
index 0000000..024ce19
--- /dev/null
@@ -0,0 +1,40 @@
+/*
+Copyright 2020 Huawei Technologies Co., Ltd.
+
+Licensed under the Apache License, Version 2.0 (the "License");
+you may not use this file except in compliance with the License.
+You may obtain a copy of the License at
+
+    http://www.apache.org/licenses/LICENSE-2.0
+
+Unless required by applicable law or agreed to in writing, software
+distributed under the License is distributed on an "AS IS" BASIS,
+WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+See the License for the specific language governing permissions and
+limitations under the License.
+*/
+package init
+
+import (
+
+       setup "ealt/cmd/setup"
+
+       "github.com/spf13/cobra"
+)
+
+// allCmd represents the all command
+func NewAllCommand() *cobra.Command {
+       var cmd = &cobra.Command{
+               Use:   "all",
+               Short: "Uninstall Complete EALT Deployment Environment",
+               Long:  `Uninstall Complete EALT Deployment Environment`,
+               RunE: func(cmd *cobra.Command, args []string) error {
+                       err := setup.EaltReset("all")
+                       if err != nil {
+                               return err
+                       }
+                       return nil
+               },
+       }
+       return cmd
+}
diff --git a/ocd/cli/ealt/cmd/clean/edge.go b/ocd/cli/ealt/cmd/clean/edge.go
new file mode 100644 (file)
index 0000000..031bdac
--- /dev/null
@@ -0,0 +1,39 @@
+/*
+Copyright 2020 Huawei Technologies Co., Ltd.
+
+Licensed under the Apache License, Version 2.0 (the "License");
+you may not use this file except in compliance with the License.
+You may obtain a copy of the License at
+
+    http://www.apache.org/licenses/LICENSE-2.0
+
+Unless required by applicable law or agreed to in writing, software
+distributed under the License is distributed on an "AS IS" BASIS,
+WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+See the License for the specific language governing permissions and
+limitations under the License.
+*/
+package init
+
+import (
+
+       setup "ealt/cmd/setup"
+
+       "github.com/spf13/cobra"
+)
+
+func NewEdgeCommand() *cobra.Command {
+       var cmd = &cobra.Command{
+               Use:   "edge",
+               Short: "Unnstall Edge Node",
+               Long:  `Command to Uninstall Edge Node only For Example : ealt clean edge`,
+               RunE: func(cmd *cobra.Command, args []string) error {
+                       err := setup.EaltReset("edge")
+                       if err != nil {
+                               return err
+                       }
+                       return nil
+               },
+       }
+       return cmd
+}
diff --git a/ocd/cli/ealt/cmd/clean/infra.go b/ocd/cli/ealt/cmd/clean/infra.go
new file mode 100644 (file)
index 0000000..324ec1d
--- /dev/null
@@ -0,0 +1,38 @@
+/*
+Copyright 2020 Huawei Technologies Co., Ltd.
+
+Licensed under the Apache License, Version 2.0 (the "License");
+you may not use this file except in compliance with the License.
+You may obtain a copy of the License at
+
+    http://www.apache.org/licenses/LICENSE-2.0
+
+Unless required by applicable law or agreed to in writing, software
+distributed under the License is distributed on an "AS IS" BASIS,
+WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+See the License for the specific language governing permissions and
+limitations under the License.
+*/
+package init
+
+import (
+       setup "ealt/cmd/setup"
+
+       "github.com/spf13/cobra"
+)
+
+func NewInfraCommand() *cobra.Command {
+       var cmd = &cobra.Command{
+               Use:   "infra",
+               Short: "Uninstall only infrastructure components on MECM and Edge Node",
+               Long:  `Command to Uninstall only infrastructure components on MECM and Edge Node For Example : ealt clean  infra`,             
+               RunE: func(cmd *cobra.Command, args []string) error {
+                       err := setup.EaltReset("infra")
+                       if err != nil {
+                               return err
+                       }
+                       return nil
+               },
+       }
+       return cmd
+}
diff --git a/ocd/cli/ealt/cmd/clean/k3s.go b/ocd/cli/ealt/cmd/clean/k3s.go
new file mode 100644 (file)
index 0000000..9c17898
--- /dev/null
@@ -0,0 +1,39 @@
+/*
+Copyright 2020 Huawei Technologies Co., Ltd.
+
+Licensed under the Apache License, Version 2.0 (the "License");
+you may not use this file except in compliance with the License.
+You may obtain a copy of the License at
+
+    http://www.apache.org/licenses/LICENSE-2.0
+
+Unless required by applicable law or agreed to in writing, software
+distributed under the License is distributed on an "AS IS" BASIS,
+WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+See the License for the specific language governing permissions and
+limitations under the License.
+*/
+package init
+
+import (
+       setup "ealt/cmd/setup"
+
+       "github.com/spf13/cobra"
+)
+
+// allCmd represents the all command
+func NewK3SCommand() *cobra.Command {
+       var cmd = &cobra.Command{
+               Use:   "k3s",
+               Short: "Command to uninstall K3S cluster on Edge Node",
+               Long:  `Command to uninstall K3S cluster on Edge Node`,
+               RunE: func(cmd *cobra.Command, args []string) error {
+                       err := setup.EaltReset("k3s")
+                       if err != nil {
+                               return err
+                       }
+                       return nil
+               },
+       }
+       return cmd
+}
diff --git a/ocd/cli/ealt/cmd/clean/k8s.go b/ocd/cli/ealt/cmd/clean/k8s.go
new file mode 100644 (file)
index 0000000..db49da9
--- /dev/null
@@ -0,0 +1,39 @@
+/*
+Copyright 2020 Huawei Technologies Co., Ltd.
+
+Licensed under the Apache License, Version 2.0 (the "License");
+you may not use this file except in compliance with the License.
+You may obtain a copy of the License at
+
+    http://www.apache.org/licenses/LICENSE-2.0
+
+Unless required by applicable law or agreed to in writing, software
+distributed under the License is distributed on an "AS IS" BASIS,
+WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+See the License for the specific language governing permissions and
+limitations under the License.
+*/
+package init
+
+import (
+       "ealt/cmd/setup"
+
+       "github.com/spf13/cobra"
+)
+
+// allCmd represents the all command
+func NewK8SCommand() *cobra.Command {
+       var cmd = &cobra.Command{
+               Use:   "k8s",
+               Short: "Command to uninstall K8S cluster on MECM Node",
+               Long:  `Command to uninstall K8S cluster on MECM Node`,
+               RunE: func(cmd *cobra.Command, args []string) error {
+                       err := setup.EaltReset("k8s")
+                       if err != nil {
+                               return err
+                       }
+                       return nil
+               },
+       }
+       return cmd
+}
diff --git a/ocd/cli/ealt/cmd/clean/mecm.go b/ocd/cli/ealt/cmd/clean/mecm.go
new file mode 100644 (file)
index 0000000..fe29e1a
--- /dev/null
@@ -0,0 +1,39 @@
+/*
+Copyright 2020 Huawei Technologies Co., Ltd.
+
+Licensed under the Apache License, Version 2.0 (the "License");
+you may not use this file except in compliance with the License.
+You may obtain a copy of the License at
+
+    http://www.apache.org/licenses/LICENSE-2.0
+
+Unless required by applicable law or agreed to in writing, software
+distributed under the License is distributed on an "AS IS" BASIS,
+WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+See the License for the specific language governing permissions and
+limitations under the License.
+*/
+package init
+
+import (
+       setup "ealt/cmd/setup"
+
+       "github.com/spf13/cobra"
+)
+
+// allCmd represents the all command
+func NewMecmCommand() *cobra.Command {
+       var cmd = &cobra.Command{
+               Use:   "manager",
+               Short: "Command to install MECM Controller",
+               Long:  `Command to Install MECM Controller Node`,
+               RunE: func(cmd *cobra.Command, args []string) error {
+                       err := setup.EaltReset("manager")
+                       if err != nil {
+                               return err
+                       }
+                       return nil
+               },
+       }
+       return cmd
+}
diff --git a/ocd/cli/ealt/cmd/init.go b/ocd/cli/ealt/cmd/init.go
new file mode 100644 (file)
index 0000000..b6c7f29
--- /dev/null
@@ -0,0 +1,54 @@
+/*
+Copyright 2020 Huawei Technologies Co., Ltd.
+
+Licensed under the Apache License, Version 2.0 (the "License");
+you may not use this file except in compliance with the License.
+You may obtain a copy of the License at
+
+    http://www.apache.org/licenses/LICENSE-2.0
+
+Unless required by applicable law or agreed to in writing, software
+distributed under the License is distributed on an "AS IS" BASIS,
+WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+See the License for the specific language governing permissions and
+limitations under the License.
+*/
+package cmd
+
+import (
+
+       initCmds "ealt/cmd/init"
+
+       "github.com/spf13/cobra"
+)
+
+// initCmd represents the init command
+var initCmd = &cobra.Command{
+       Use:   "init",
+       Short: "This command is used to install various components of EALT",
+       Long: `Command has multiple options to handle installation of each components.
+       Options :
+       "all" : To install the complete EALT Environment.
+       "mecm": To install the MECM - Controller Node
+       "mep" : To install the MEP - Edge Node`,
+}
+
+func init() {
+       //Adding the various sub-commands of init command
+       //Adding all subcommand to init 
+       initCmd.AddCommand(initCmds.NewAllCommand())
+       //ealt init infra
+       initCmd.AddCommand(initCmds.NewInfraCommand())
+       //ealt init manager
+       initCmd.AddCommand(initCmds.NewMecmCommand())
+       //ealt init edge
+       initCmd.AddCommand(initCmds.NewEdgeCommand())
+       //ealt init k8s
+       initCmd.AddCommand(initCmds.NewK8SCommand())
+       //ealt init k3s
+       initCmd.AddCommand(initCmds.NewK3SCommand())
+
+       //Add init subcommand to root command.
+       rootCmd.AddCommand(initCmd)
+
+}
diff --git a/ocd/cli/ealt/cmd/init/all.go b/ocd/cli/ealt/cmd/init/all.go
new file mode 100644 (file)
index 0000000..1654a16
--- /dev/null
@@ -0,0 +1,40 @@
+/*
+Copyright 2020 Huawei Technologies Co., Ltd.
+
+Licensed under the Apache License, Version 2.0 (the "License");
+you may not use this file except in compliance with the License.
+You may obtain a copy of the License at
+
+    http://www.apache.org/licenses/LICENSE-2.0
+
+Unless required by applicable law or agreed to in writing, software
+distributed under the License is distributed on an "AS IS" BASIS,
+WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+See the License for the specific language governing permissions and
+limitations under the License.
+*/
+package init
+
+import (
+
+       setup "ealt/cmd/setup"
+
+       "github.com/spf13/cobra"
+)
+
+// allCmd represents the all command
+func NewAllCommand() *cobra.Command {
+       var cmd = &cobra.Command{
+               Use:   "all",
+               Short: "Install Complete EALT Deployment Environment",
+               Long:  `Install Complete EALT Deployment Environment`,
+               RunE: func(cmd *cobra.Command, args []string) error {
+                       err := setup.EaltInstall("all")
+                       if err != nil {
+                               return err
+                       }
+                       return nil
+               },
+       }
+       return cmd
+}
diff --git a/ocd/cli/ealt/cmd/init/edge.go b/ocd/cli/ealt/cmd/init/edge.go
new file mode 100644 (file)
index 0000000..8cce554
--- /dev/null
@@ -0,0 +1,41 @@
+/*
+Copyright 2020 Huawei Technologies Co., Ltd.
+
+Licensed under the Apache License, Version 2.0 (the "License");
+you may not use this file except in compliance with the License.
+You may obtain a copy of the License at
+
+    http://www.apache.org/licenses/LICENSE-2.0
+
+Unless required by applicable law or agreed to in writing, software
+distributed under the License is distributed on an "AS IS" BASIS,
+WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+See the License for the specific language governing permissions and
+limitations under the License.
+*/
+package init
+
+import (
+       "fmt"
+
+       setup "ealt/cmd/setup"
+
+       "github.com/spf13/cobra"
+)
+
+func NewEdgeCommand() *cobra.Command {
+       var cmd = &cobra.Command{
+               Use:   "edge",
+               Short: "Install Edge Node",
+               Long:  `Command to Install Edge Node only For Example : ealt init edge`,
+               RunE: func(cmd *cobra.Command, args []string) error {
+                       fmt.Println("Installation of Edge components")
+                       err := setup.EaltInstall("edge")
+                       if err != nil {
+                               return err
+                       }
+                       return nil
+               },
+       }
+       return cmd
+}
diff --git a/ocd/cli/ealt/cmd/init/infra.go b/ocd/cli/ealt/cmd/init/infra.go
new file mode 100644 (file)
index 0000000..3e963ef
--- /dev/null
@@ -0,0 +1,38 @@
+/*
+Copyright 2020 Huawei Technologies Co., Ltd.
+
+Licensed under the Apache License, Version 2.0 (the "License");
+you may not use this file except in compliance with the License.
+You may obtain a copy of the License at
+
+    http://www.apache.org/licenses/LICENSE-2.0
+
+Unless required by applicable law or agreed to in writing, software
+distributed under the License is distributed on an "AS IS" BASIS,
+WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+See the License for the specific language governing permissions and
+limitations under the License.
+*/
+package init
+
+import (
+       setup "ealt/cmd/setup"
+
+       "github.com/spf13/cobra"
+)
+
+func NewInfraCommand() *cobra.Command {
+       var cmd = &cobra.Command{
+               Use:   "infra",
+               Short: "Install only infrastructure components on MECM and Edge Node",
+               Long:  `Command to install only infrastructure components on MECM and Edge Node For Example : ealt init infra`,         
+               RunE: func(cmd *cobra.Command, args []string) error {
+                       err := setup.EaltInstall("infra")
+                       if err != nil {
+                               return err
+                       }
+                       return nil
+               },
+       }
+       return cmd
+}
diff --git a/ocd/cli/ealt/cmd/init/k3s.go b/ocd/cli/ealt/cmd/init/k3s.go
new file mode 100644 (file)
index 0000000..4b3f080
--- /dev/null
@@ -0,0 +1,39 @@
+/*
+Copyright 2020 Huawei Technologies Co., Ltd.
+
+Licensed under the Apache License, Version 2.0 (the "License");
+you may not use this file except in compliance with the License.
+You may obtain a copy of the License at
+
+    http://www.apache.org/licenses/LICENSE-2.0
+
+Unless required by applicable law or agreed to in writing, software
+distributed under the License is distributed on an "AS IS" BASIS,
+WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+See the License for the specific language governing permissions and
+limitations under the License.
+*/
+package init
+
+import (
+       "ealt/cmd/setup"
+
+       "github.com/spf13/cobra"
+)
+
+// allCmd represents the all command
+func NewK3SCommand() *cobra.Command {
+       var cmd = &cobra.Command{
+               Use:   "k3s",
+               Short: "Command to install K3S cluster on Edge Node",
+               Long:  `Command to install K3S cluster on Edge Node`,
+               RunE: func(cmd *cobra.Command, args []string) error {
+                       err := setup.EaltInstall("k3s")
+                       if err != nil {
+                               return err
+                       }
+                       return nil
+               },
+       }
+       return cmd
+}
diff --git a/ocd/cli/ealt/cmd/init/k8s.go b/ocd/cli/ealt/cmd/init/k8s.go
new file mode 100644 (file)
index 0000000..c92c9e4
--- /dev/null
@@ -0,0 +1,39 @@
+/*
+Copyright 2020 Huawei Technologies Co., Ltd.
+
+Licensed under the Apache License, Version 2.0 (the "License");
+you may not use this file except in compliance with the License.
+You may obtain a copy of the License at
+
+    http://www.apache.org/licenses/LICENSE-2.0
+
+Unless required by applicable law or agreed to in writing, software
+distributed under the License is distributed on an "AS IS" BASIS,
+WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+See the License for the specific language governing permissions and
+limitations under the License.
+*/
+package init
+
+import (
+       "ealt/cmd/setup"
+
+       "github.com/spf13/cobra"
+)
+
+// allCmd represents the all command
+func NewK8SCommand() *cobra.Command {
+       var cmd = &cobra.Command{
+               Use:   "k8s",
+               Short: "Command to install K8S cluster on MECM Node",
+               Long:  `Command to install K8S cluster on MECM Node`,
+               RunE: func(cmd *cobra.Command, args []string) error {
+                       err := setup.EaltInstall("k8s")
+                       if err != nil {
+                               return err
+                       }
+                       return nil
+               },
+       }
+       return cmd
+}
diff --git a/ocd/cli/ealt/cmd/init/mecm.go b/ocd/cli/ealt/cmd/init/mecm.go
new file mode 100644 (file)
index 0000000..666c308
--- /dev/null
@@ -0,0 +1,39 @@
+/*
+Copyright 2020 Huawei Technologies Co., Ltd.
+
+Licensed under the Apache License, Version 2.0 (the "License");
+you may not use this file except in compliance with the License.
+You may obtain a copy of the License at
+
+    http://www.apache.org/licenses/LICENSE-2.0
+
+Unless required by applicable law or agreed to in writing, software
+distributed under the License is distributed on an "AS IS" BASIS,
+WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+See the License for the specific language governing permissions and
+limitations under the License.
+*/
+package init
+
+import (
+       "ealt/cmd/setup"
+
+       "github.com/spf13/cobra"
+)
+
+// allCmd represents the all command
+func NewMecmCommand() *cobra.Command {
+       var cmd = &cobra.Command{
+               Use:   "manager",
+               Short: "Command to install MECM Controller",
+               Long:  `Command to Install MECM Controller Node`,
+               RunE: func(cmd *cobra.Command, args []string) error {
+                       err := setup.EaltInstall("mecm")
+                       if err != nil {
+                               return err
+                       }
+                       return nil
+               },
+       }
+       return cmd
+}
diff --git a/ocd/cli/ealt/cmd/root.go b/ocd/cli/ealt/cmd/root.go
new file mode 100644 (file)
index 0000000..7299e75
--- /dev/null
@@ -0,0 +1,50 @@
+/*
+ * Copyright 2020 Huawei Technologies Co., Ltd.
+ *
+ * Licensed under the Apache License, Version 2.0 (the "License");
+ * you may not use this file except in compliance with the License.
+ * You may obtain a copy of the License at
+ *
+ *     http://www.apache.org/licenses/LICENSE-2.0
+ *
+ * Unless required by applicable law or agreed to in writing, software
+ * distributed under the License is distributed on an "AS IS" BASIS,
+ * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+ * See the License for the specific language governing permissions and
+ * limitations under the License.
+ */
+package cmd
+
+
+ import (
+       "fmt"
+       "os"
+
+       "github.com/spf13/cobra"
+)
+
+var cfgFile string
+
+// rootCmd represents the base command when called without any subcommands
+var rootCmd = &cobra.Command{
+       Use:   "ealt",
+       Short: "Command Line Interface for EALTEdge ",
+       Long: `Command Line Interface to deploy and manage EALTEdge Environment. 
+       The operations supported by CLI commands are 
+       .`,
+       // Uncomment the following line if your bare application
+       // has an action associated with it:
+       //      Run: func(cmd *cobra.Command, args []string) { },
+}
+
+// Execute adds all child commands to the root command and sets flags appropriately.
+// This is called by main.main(). It only needs to happen once to the rootCmd.
+func Execute() {
+       if err := rootCmd.Execute(); err != nil {
+               fmt.Println(err)
+               os.Exit(1)
+       }
+}
+
+func init() {
+}
\ No newline at end of file
diff --git a/ocd/cli/ealt/cmd/setup/common.go b/ocd/cli/ealt/cmd/setup/common.go
new file mode 100644 (file)
index 0000000..e0b8468
--- /dev/null
@@ -0,0 +1,102 @@
+/*
+Copyright 2020 Huawei Technologies Co., Ltd.
+
+Licensed under the Apache License, Version 2.0 (the "License");
+you may not use this file except in compliance with the License.
+You may obtain a copy of the License at
+
+    http://www.apache.org/licenses/LICENSE-2.0
+
+Unless required by applicable law or agreed to in writing, software
+distributed under the License is distributed on an "AS IS" BASIS,
+WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+See the License for the specific language governing permissions and
+limitations under the License.
+*/
+
+// runCommandWithShell executes the given command with "sh -c".
+// It returns an error if the command outputs anything on the stderr.
+package setup
+
+
+import (
+       "bytes"
+       "fmt"
+       "io"
+       "os"
+       "os/exec"
+       "strings"
+       "sync"
+)
+
+//Command defines commands to be executed and captures std out and std error
+type Command struct {
+       Cmd    *exec.Cmd
+       StdOut []byte
+       StdErr []byte
+}
+
+func (cm Command) GetStdOutput() string {
+       if len(cm.StdOut) != 0 {
+               return strings.TrimRight(string(cm.StdOut), "\n")
+       }
+       return ""
+}
+
+//GetStdErr gets StdErr field
+func (cm Command) GetStdErr() string {
+       if len(cm.StdErr) != 0 {
+               return strings.TrimRight(string(cm.StdErr), "\n")
+       }
+       return ""
+}
+
+//It helps in the commands where it takes some time for execution.
+func (cm Command) ExecuteCmdShowOutput() error {
+       var stdoutBuf, stderrBuf bytes.Buffer
+       stdoutIn, _ := cm.Cmd.StdoutPipe()
+       stderrIn, _ := cm.Cmd.StderrPipe()
+
+       var errStdout, errStderr error
+       stdout := io.MultiWriter(os.Stdout, &stdoutBuf)
+       stderr := io.MultiWriter(os.Stderr, &stderrBuf)
+       err := cm.Cmd.Start()
+       if err != nil {
+               return fmt.Errorf("failed to start '%s' because of error : %s", strings.Join(cm.Cmd.Args, " "), err.Error())
+       }
+
+       var wg sync.WaitGroup
+       wg.Add(1)
+
+       go func() {
+               _, errStdout = io.Copy(stdout, stdoutIn)
+               wg.Done()
+       }()
+
+       _, errStderr = io.Copy(stderr, stderrIn)
+       wg.Wait()
+
+       err = cm.Cmd.Wait()
+       if err != nil {
+               return fmt.Errorf("failed to run '%s' because of error : %s", strings.Join(cm.Cmd.Args, " "), err.Error())
+       }
+       if errStdout != nil || errStderr != nil {
+               return fmt.Errorf("failed to capture stdout or stderr")
+       }
+
+       cm.StdOut, cm.StdErr = stdoutBuf.Bytes(), stderrBuf.Bytes()
+       return nil
+}
+
+func runCommandAtShell(command string) (string, error) {
+    cmd := &Command{Cmd: exec.Command("sh", "-c", command)}
+    err := cmd.ExecuteCmdShowOutput()
+    if err != nil {
+            return "", err
+    }
+    errout := cmd.GetStdErr()
+    if errout != "" {
+            return "", fmt.Errorf("%s", errout)
+    }
+    return cmd.GetStdOutput(), nil
+}
diff --git a/ocd/cli/ealt/cmd/setup/install.go b/ocd/cli/ealt/cmd/setup/install.go
new file mode 100644 (file)
index 0000000..e9a771d
--- /dev/null
@@ -0,0 +1,75 @@
+/*
+Copyright 2020 Huawei Technologies Co., Ltd.
+
+Licensed under the Apache License, Version 2.0 (the "License");
+you may not use this file except in compliance with the License.
+You may obtain a copy of the License at
+
+    http://www.apache.org/licenses/LICENSE-2.0
+
+Unless required by applicable law or agreed to in writing, software
+distributed under the License is distributed on an "AS IS" BASIS,
+WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+See the License for the specific language governing permissions and
+limitations under the License.
+*/
+package setup
+
+
+import (
+       "fmt"
+)
+func EaltInstall(component string) error {
+       var strEaltSetup string
+       switch component {
+       case "all":
+               strEaltSetup = fmt.Sprintf("ansible-playbook ealt-all.yml -i ealt-inventory.ini --extra-vars \"operation=install\"")
+       case "infra":
+               strEaltSetup = fmt.Sprintf("ansible-playbook ealt-all.yml -i ealt-inventory.ini --tags \"infra\" --extra-vars \"operation=install\"")
+       case "manager":
+               strEaltSetup = fmt.Sprintf("ansible-playbook ealt-all.yml -i ealt-inventory.ini --tags \"mecm\" --extra-vars \"operation=install\"")
+       case "edge":
+               strEaltSetup = fmt.Sprintf("ansible-playbook ealt-all.yml -i ealt-inventory.ini --tags \"mep\" --extra-vars \"operation=install\"")
+       case "k8s":
+               strEaltSetup = fmt.Sprintf("ansible-playbook ealt-all.yml -i ealt-inventory.ini --tags \"k8s\" --extra-vars \"operation=install\"")
+       case "k3s":
+               strEaltSetup = fmt.Sprintf("ansible-playbook ealt-all.yml -i ealt-inventory.ini --tags \"k3s\" --extra-vars \"operation=install\"")             
+       default:
+               fmt.Println("Provide subcommand for ealt init [all|infra|manager|edge|k8s|k3s]")
+       }
+
+       stdout, err := runCommandAtShell(strEaltSetup)
+       if err != nil {
+               return err
+       }
+       fmt.Println(stdout)
+       return nil
+}
+
+func EaltReset(component string) error {
+       var strEaltReset string
+
+       switch component {
+       case "all":
+               strEaltReset = fmt.Sprintf("ansible-playbook ealt-all-uninstall.yml -i ealt-inventory.ini --extra-vars \"operation=uninstall\"")
+       case "infra":
+               strEaltReset = fmt.Sprintf("ansible-playbook ealt-all-uninstall.yml -i ealt-inventory.ini --tags \"infra\" --extra-vars \"operation=uninstall\"")
+       case "manager":
+               strEaltReset = fmt.Sprintf("ansible-playbook ealt-all-uninstall.yml -i ealt-inventory.ini --tags \"mecm\" --extra-vars \"operation=uninstall\"")
+       case "edge":
+               strEaltReset = fmt.Sprintf("ansible-playbook ealt-all-uninstall.yml -i ealt-inventory.ini --tags \"mep\" --extra-vars \"operation=uninstall\"")
+       case "k8s":
+               strEaltReset = fmt.Sprintf("ansible-playbook ealt-all-uninstall.yml -i ealt-inventory.ini --tags \"k8s\" --extra-vars \"operation=uninstall\"")
+       case "k3s":
+               strEaltReset = fmt.Sprintf("ansible-playbook ealt-all-uninstall.yml -i ealt-inventory.ini --tags \"k3s\" --extra-vars \"operation=uninstall\"")         
+       default:
+               fmt.Println("Provide subcommand for ealt clean [all|infra|manager|edge|k8s|k3s]")
+       }
+
+       stdout, err := runCommandAtShell(strEaltReset)
+       if err != nil {
+               return err
+       }
+       fmt.Println(stdout)
+       return nil
+}
\ No newline at end of file
diff --git a/ocd/cli/ealt/go.mod b/ocd/cli/ealt/go.mod
new file mode 100644 (file)
index 0000000..a2cf0b9
--- /dev/null
@@ -0,0 +1,5 @@
+module ealt
+
+go 1.14
+
+require github.com/spf13/cobra v1.0.0
diff --git a/ocd/cli/ealt/go.sum b/ocd/cli/ealt/go.sum
new file mode 100644 (file)
index 0000000..a72f1c3
--- /dev/null
@@ -0,0 +1,126 @@
+cloud.google.com/go v0.26.0/go.mod h1:aQUYkXzVsufM+DwF1aE+0xfcU+56JwCaLick0ClmMTw=
+github.com/BurntSushi/toml v0.3.1/go.mod h1:xHWCNGjB5oqiDr8zfno3MHue2Ht5sIBksp03qcyfWMU=
+github.com/OneOfOne/xxhash v1.2.2/go.mod h1:HSdplMjZKSmBqAxg5vPj2TmRDmfkzw+cTzAElWljhcU=
+github.com/alecthomas/template v0.0.0-20160405071501-a0175ee3bccc/go.mod h1:LOuyumcjzFXgccqObfd/Ljyb9UuFJ6TxHnclSeseNhc=
+github.com/alecthomas/units v0.0.0-20151022065526-2efee857e7cf/go.mod h1:ybxpYRFXyAe+OPACYpWeL0wqObRcbAqCMya13uyzqw0=
+github.com/armon/consul-api v0.0.0-20180202201655-eb2c6b5be1b6/go.mod h1:grANhF5doyWs3UAsr3K4I6qtAmlQcZDesFNEHPZAzj8=
+github.com/beorn7/perks v0.0.0-20180321164747-3a771d992973/go.mod h1:Dwedo/Wpr24TaqPxmxbtue+5NUziq4I4S80YR8gNf3Q=
+github.com/beorn7/perks v1.0.0/go.mod h1:KWe93zE9D1o94FZ5RNwFwVgaQK1VOXiVxmqh+CedLV8=
+github.com/cespare/xxhash v1.1.0/go.mod h1:XrSqR1VqqWfGrhpAt58auRo0WTKS1nRRg3ghfAqPWnc=
+github.com/client9/misspell v0.3.4/go.mod h1:qj6jICC3Q7zFZvVWo7KLAzC3yx5G7kyvSDkc90ppPyw=
+github.com/coreos/bbolt v1.3.2/go.mod h1:iRUV2dpdMOn7Bo10OQBFzIJO9kkE559Wcmn+qkEiiKk=
+github.com/coreos/etcd v3.3.10+incompatible/go.mod h1:uF7uidLiAD3TWHmW31ZFd/JWoc32PjwdhPthX9715RE=
+github.com/coreos/go-semver v0.2.0/go.mod h1:nnelYz7RCh+5ahJtPPxZlU+153eP4D4r3EedlOD2RNk=
+github.com/coreos/go-systemd v0.0.0-20190321100706-95778dfbb74e/go.mod h1:F5haX7vjVVG0kc13fIWeqUViNPyEJxv/OmvnBo0Yme4=
+github.com/coreos/pkg v0.0.0-20180928190104-399ea9e2e55f/go.mod h1:E3G3o1h8I7cfcXa63jLwjI0eiQQMgzzUDFVpN/nH/eA=
+github.com/cpuguy83/go-md2man/v2 v2.0.0/go.mod h1:maD7wRr/U5Z6m/iR4s+kqSMx2CaBsrgA7czyZG/E6dU=
+github.com/davecgh/go-spew v1.1.1/go.mod h1:J7Y8YcW2NihsgmVo/mv3lAwl/skON4iLHjSsI+c5H38=
+github.com/dgrijalva/jwt-go v3.2.0+incompatible/go.mod h1:E3ru+11k8xSBh+hMPgOLZmtrrCbhqsmaPHjLKYnJCaQ=
+github.com/dgryski/go-sip13 v0.0.0-20181026042036-e10d5fee7954/go.mod h1:vAd38F8PWV+bWy6jNmig1y/TA+kYO4g3RSRF0IAv0no=
+github.com/fsnotify/fsnotify v1.4.7/go.mod h1:jwhsz4b93w/PPRr/qN1Yymfu8t87LnFCMoQvtojpjFo=
+github.com/ghodss/yaml v1.0.0/go.mod h1:4dBDuWmgqj2HViK6kFavaiC9ZROes6MMH2rRYeMEF04=
+github.com/go-kit/kit v0.8.0/go.mod h1:xBxKIO96dXMWWy0MnWVtmwkA9/13aqxPnvrjFYMA2as=
+github.com/go-logfmt/logfmt v0.3.0/go.mod h1:Qt1PoO58o5twSAckw1HlFXLmHsOX5/0LbT9GBnD5lWE=
+github.com/go-logfmt/logfmt v0.4.0/go.mod h1:3RMwSq7FuexP4Kalkev3ejPJsZTpXXBr9+V4qmtdjCk=
+github.com/go-stack/stack v1.8.0/go.mod h1:v0f6uXyyMGvRgIKkXu+yp6POWl0qKG85gN/melR3HDY=
+github.com/gogo/protobuf v1.1.1/go.mod h1:r8qH/GZQm5c6nD/R0oafs1akxWv10x8SbQlK7atdtwQ=
+github.com/gogo/protobuf v1.2.1/go.mod h1:hp+jE20tsWTFYpLwKvXlhS1hjn+gTNwPg2I6zVXpSg4=
+github.com/golang/glog v0.0.0-20160126235308-23def4e6c14b/go.mod h1:SBH7ygxi8pfUlaOkMMuAQtPIUF8ecWP5IEl/CR7VP2Q=
+github.com/golang/groupcache v0.0.0-20190129154638-5b532d6fd5ef/go.mod h1:cIg4eruTrX1D+g88fzRXU5OdNfaM+9IcxsU14FzY7Hc=
+github.com/golang/mock v1.1.1/go.mod h1:oTYuIxOrZwtPieC+H1uAHpcLFnEyAGVDL/k47Jfbm0A=
+github.com/golang/protobuf v1.2.0/go.mod h1:6lQm79b+lXiMfvg/cZm0SGofjICqVBUtrP5yJMmIC1U=
+github.com/golang/protobuf v1.3.1/go.mod h1:6lQm79b+lXiMfvg/cZm0SGofjICqVBUtrP5yJMmIC1U=
+github.com/google/btree v1.0.0/go.mod h1:lNA+9X1NB3Zf8V7Ke586lFgjr2dZNuvo3lPJSGZ5JPQ=
+github.com/google/go-cmp v0.2.0/go.mod h1:oXzfMopK8JAjlY9xF4vHSVASa0yLyX7SntLO5aqRK0M=
+github.com/gorilla/websocket v1.4.0/go.mod h1:E7qHFY5m1UJ88s3WnNqhKjPHQ0heANvMoAMk2YaljkQ=
+github.com/grpc-ecosystem/go-grpc-middleware v1.0.0/go.mod h1:FiyG127CGDf3tlThmgyCl78X/SZQqEOJBCDaAfeWzPs=
+github.com/grpc-ecosystem/go-grpc-prometheus v1.2.0/go.mod h1:8NvIoxWQoOIhqOTXgfV/d3M/q6VIi02HzZEHgUlZvzk=
+github.com/grpc-ecosystem/grpc-gateway v1.9.0/go.mod h1:vNeuVxBJEsws4ogUvrchl83t/GYV9WGTSLVdBhOQFDY=
+github.com/hashicorp/hcl v1.0.0/go.mod h1:E5yfLk+7swimpb2L/Alb/PJmXilQ/rhwaUYs4T20WEQ=
+github.com/inconshreveable/mousetrap v1.0.0/go.mod h1:PxqpIevigyE2G7u3NXJIT2ANytuPF1OarO4DADm73n8=
+github.com/jonboulle/clockwork v0.1.0/go.mod h1:Ii8DK3G1RaLaWxj9trq07+26W01tbo22gdxWY5EU2bo=
+github.com/julienschmidt/httprouter v1.2.0/go.mod h1:SYymIcj16QtmaHHD7aYtjjsJG7VTCxuUUipMqKk8s4w=
+github.com/kisielk/errcheck v1.1.0/go.mod h1:EZBBE59ingxPouuu3KfxchcWSUPOHkagtvWXihfKN4Q=
+github.com/kisielk/gotool v1.0.0/go.mod h1:XhKaO+MFFWcvkIS/tQcRk01m1F5IRFswLeQ+oQHNcck=
+github.com/konsorten/go-windows-terminal-sequences v1.0.1/go.mod h1:T0+1ngSBFLxvqU3pZ+m/2kptfBszLMUkC4ZK/EgS/cQ=
+github.com/kr/logfmt v0.0.0-20140226030751-b84e30acd515/go.mod h1:+0opPa2QZZtGFBFZlji/RkVcI2GknAs/DXo4wKdlNEc=
+github.com/kr/pretty v0.1.0/go.mod h1:dAy3ld7l9f0ibDNOQOHHMYYIIbhfbHSm3C4ZsoJORNo=
+github.com/kr/pty v1.1.1/go.mod h1:pFQYn66WHrOpPYNljwOMqo10TkYh1fy3cYio2l3bCsQ=
+github.com/kr/text v0.1.0/go.mod h1:4Jbv+DJW3UT/LiOwJeYQe1efqtUx/iVham/4vfdArNI=
+github.com/magiconair/properties v1.8.0/go.mod h1:PppfXfuXeibc/6YijjN8zIbojt8czPbwD3XqdrwzmxQ=
+github.com/matttproud/golang_protobuf_extensions v1.0.1/go.mod h1:D8He9yQNgCq6Z5Ld7szi9bcBfOoFv/3dc6xSMkL2PC0=
+github.com/mitchellh/go-homedir v1.1.0/go.mod h1:SfyaCUpYCn1Vlf4IUYiD9fPX4A5wJrkLzIz1N1q0pr0=
+github.com/mitchellh/mapstructure v1.1.2/go.mod h1:FVVH3fgwuzCH5S8UJGiWEs2h04kUh9fWfEaFds41c1Y=
+github.com/mwitkow/go-conntrack v0.0.0-20161129095857-cc309e4a2223/go.mod h1:qRWi+5nqEBWmkhHvq77mSJWrCKwh8bxhgT7d/eI7P4U=
+github.com/oklog/ulid v1.3.1/go.mod h1:CirwcVhetQ6Lv90oh/F+FBtV6XMibvdAFo93nm5qn4U=
+github.com/pelletier/go-toml v1.2.0/go.mod h1:5z9KED0ma1S8pY6P1sdut58dfprrGBbd/94hg7ilaic=
+github.com/pkg/errors v0.8.0/go.mod h1:bwawxfHBFNV+L2hUp1rHADufV3IMtnDRdf1r5NINEl0=
+github.com/pmezard/go-difflib v1.0.0/go.mod h1:iKH77koFhYxTK1pcRnkKkqfTogsbg7gZNVY4sRDYZ/4=
+github.com/prometheus/client_golang v0.9.1/go.mod h1:7SWBe2y4D6OKWSNQJUaRYU/AaXPKyh/dDVn+NZz0KFw=
+github.com/prometheus/client_golang v0.9.3/go.mod h1:/TN21ttK/J9q6uSwhBd54HahCDft0ttaMvbicHlPoso=
+github.com/prometheus/client_model v0.0.0-20180712105110-5c3871d89910/go.mod h1:MbSGuTsp3dbXC40dX6PRTWyKYBIrTGTE9sqQNg2J8bo=
+github.com/prometheus/client_model v0.0.0-20190129233127-fd36f4220a90/go.mod h1:xMI15A0UPsDsEKsMN9yxemIoYk6Tm2C1GtYGdfGttqA=
+github.com/prometheus/common v0.0.0-20181113130724-41aa239b4cce/go.mod h1:daVV7qP5qjZbuso7PdcryaAu0sAZbrN9i7WWcTMWvro=
+github.com/prometheus/common v0.4.0/go.mod h1:TNfzLD0ON7rHzMJeJkieUDPYmFC7Snx/y86RQel1bk4=
+github.com/prometheus/procfs v0.0.0-20181005140218-185b4288413d/go.mod h1:c3At6R/oaqEKCNdg8wHV1ftS6bRYblBhIjjI8uT2IGk=
+github.com/prometheus/procfs v0.0.0-20190507164030-5867b95ac084/go.mod h1:TjEm7ze935MbeOT/UhFTIMYKhuLP4wbCsTZCD3I8kEA=
+github.com/prometheus/tsdb v0.7.1/go.mod h1:qhTCs0VvXwvX/y3TZrWD7rabWM+ijKTux40TwIPHuXU=
+github.com/rogpeppe/fastuuid v0.0.0-20150106093220-6724a57986af/go.mod h1:XWv6SoW27p1b0cqNHllgS5HIMJraePCO15w5zCzIWYg=
+github.com/russross/blackfriday/v2 v2.0.1/go.mod h1:+Rmxgy9KzJVeS9/2gXHxylqXiyQDYRxCVz55jmeOWTM=
+github.com/shurcooL/sanitized_anchor_name v1.0.0/go.mod h1:1NzhyTcUVG4SuEtjjoZeVRXNmyL/1OwPU0+IJeTBvfc=
+github.com/sirupsen/logrus v1.2.0/go.mod h1:LxeOpSwHxABJmUn/MG1IvRgCAasNZTLOkJPxbbu5VWo=
+github.com/soheilhy/cmux v0.1.4/go.mod h1:IM3LyeVVIOuxMH7sFAkER9+bJ4dT7Ms6E4xg4kGIyLM=
+github.com/spaolacci/murmur3 v0.0.0-20180118202830-f09979ecbc72/go.mod h1:JwIasOWyU6f++ZhiEuf87xNszmSA2myDM2Kzu9HwQUA=
+github.com/spf13/afero v1.1.2/go.mod h1:j4pytiNVoe2o6bmDsKpLACNPDBIoEAkihy7loJ1B0CQ=
+github.com/spf13/cast v1.3.0/go.mod h1:Qx5cxh0v+4UWYiBimWS+eyWzqEqokIECu5etghLkUJE=
+github.com/spf13/cobra v1.0.0 h1:6m/oheQuQ13N9ks4hubMG6BnvwOeaJrqSPLahSnczz8=
+github.com/spf13/cobra v1.0.0/go.mod h1:/6GTrnGXV9HjY+aR4k0oJ5tcvakLuG6EuKReYlHNrgE=
+github.com/spf13/jwalterweatherman v1.0.0/go.mod h1:cQK4TGJAtQXfYWX+Ddv3mKDzgVb68N+wFjFa4jdeBTo=
+github.com/spf13/pflag v1.0.3 h1:zPAT6CGy6wXeQ7NtTnaTerfKOsV6V6F8agHXFiazDkg=
+github.com/spf13/pflag v1.0.3/go.mod h1:DYY7MBk1bdzusC3SYhjObp+wFpr4gzcvqqNjLnInEg4=
+github.com/spf13/viper v1.4.0/go.mod h1:PTJ7Z/lr49W6bUbkmS1V3by4uWynFiR9p7+dSq/yZzE=
+github.com/stretchr/objx v0.1.1/go.mod h1:HFkY916IF+rwdDfMAkV7OtwuqBVzrE8GR6GFx+wExME=
+github.com/stretchr/testify v1.2.2/go.mod h1:a8OnRcib4nhh0OaRAV+Yts87kKdq0PP7pXfy6kDkUVs=
+github.com/tmc/grpc-websocket-proxy v0.0.0-20190109142713-0ad062ec5ee5/go.mod h1:ncp9v5uamzpCO7NfCPTXjqaC+bZgJeR0sMTm6dMHP7U=
+github.com/ugorji/go v1.1.4/go.mod h1:uQMGLiO92mf5W77hV/PUCpI3pbzQx3CRekS0kk+RGrc=
+github.com/xiang90/probing v0.0.0-20190116061207-43a291ad63a2/go.mod h1:UETIi67q53MR2AWcXfiuqkDkRtnGDLqkBTpCHuJHxtU=
+github.com/xordataexchange/crypt v0.0.3-0.20170626215501-b2862e3d0a77/go.mod h1:aYKd//L2LvnjZzWKhF00oedf4jCCReLcmhLdhm1A27Q=
+go.etcd.io/bbolt v1.3.2/go.mod h1:IbVyRI1SCnLcuJnV2u8VeU0CEYM7e686BmAb1XKL+uU=
+go.uber.org/atomic v1.4.0/go.mod h1:gD2HeocX3+yG+ygLZcrzQJaqmWj9AIm7n08wl/qW/PE=
+go.uber.org/multierr v1.1.0/go.mod h1:wR5kodmAFQ0UK8QlbwjlSNy0Z68gJhDJUG5sjR94q/0=
+go.uber.org/zap v1.10.0/go.mod h1:vwi/ZaCAaUcBkycHslxD9B2zi4UTXhF60s6SWpuDF0Q=
+golang.org/x/crypto v0.0.0-20180904163835-0709b304e793/go.mod h1:6SG95UA2DQfeDnfUPMdvaQW0Q7yPrPDi9nlGo2tz2b4=
+golang.org/x/crypto v0.0.0-20190308221718-c2843e01d9a2/go.mod h1:djNgcEr1/C05ACkg1iLfiJU5Ep61QUkGW8qpdssI0+w=
+golang.org/x/lint v0.0.0-20181026193005-c67002cb31c3/go.mod h1:UVdnD1Gm6xHRNCYTkRU2/jEulfH38KcIWyp/GAMgvoE=
+golang.org/x/lint v0.0.0-20190313153728-d0100b6bd8b3/go.mod h1:6SW0HCj/g11FgYtHlgUYUwCkIfeOF89ocIRzGO/8vkc=
+golang.org/x/net v0.0.0-20180826012351-8a410e7b638d/go.mod h1:mL1N/T3taQHkDXs73rZJwtUhF3w3ftmwwsq0BUmARs4=
+golang.org/x/net v0.0.0-20181114220301-adae6a3d119a/go.mod h1:mL1N/T3taQHkDXs73rZJwtUhF3w3ftmwwsq0BUmARs4=
+golang.org/x/net v0.0.0-20181220203305-927f97764cc3/go.mod h1:mL1N/T3taQHkDXs73rZJwtUhF3w3ftmwwsq0BUmARs4=
+golang.org/x/net v0.0.0-20190311183353-d8887717615a/go.mod h1:t9HGtf8HONx5eT2rtn7q6eTqICYqUVnKs3thJo3Qplg=
+golang.org/x/net v0.0.0-20190522155817-f3200d17e092/go.mod h1:HSz+uSET+XFnRR8LxR5pz3Of3rY3CfYBVs4xY44aLks=
+golang.org/x/oauth2 v0.0.0-20180821212333-d2e6202438be/go.mod h1:N/0e6XlmueqKjAGxoOufVs8QHGRruUQn6yWY3a++T0U=
+golang.org/x/sync v0.0.0-20180314180146-1d60e4601c6f/go.mod h1:RxMgew5VJxzue5/jJTE5uejpjVlOe/izrB70Jof72aM=
+golang.org/x/sync v0.0.0-20181108010431-42b317875d0f/go.mod h1:RxMgew5VJxzue5/jJTE5uejpjVlOe/izrB70Jof72aM=
+golang.org/x/sync v0.0.0-20181221193216-37e7f081c4d4/go.mod h1:RxMgew5VJxzue5/jJTE5uejpjVlOe/izrB70Jof72aM=
+golang.org/x/sys v0.0.0-20180830151530-49385e6e1522/go.mod h1:STP8DvDyc/dI5b8T5hshtkjS+E42TnysNCUPdjciGhY=
+golang.org/x/sys v0.0.0-20180905080454-ebe1bf3edb33/go.mod h1:STP8DvDyc/dI5b8T5hshtkjS+E42TnysNCUPdjciGhY=
+golang.org/x/sys v0.0.0-20181107165924-66b7b1311ac8/go.mod h1:STP8DvDyc/dI5b8T5hshtkjS+E42TnysNCUPdjciGhY=
+golang.org/x/sys v0.0.0-20181116152217-5ac8a444bdc5/go.mod h1:STP8DvDyc/dI5b8T5hshtkjS+E42TnysNCUPdjciGhY=
+golang.org/x/sys v0.0.0-20190215142949-d0b11bdaac8a/go.mod h1:STP8DvDyc/dI5b8T5hshtkjS+E42TnysNCUPdjciGhY=
+golang.org/x/text v0.3.0/go.mod h1:NqM8EUOU14njkJ3fqMW+pc6Ldnwhi/IjpwHt7yyuwOQ=
+golang.org/x/time v0.0.0-20190308202827-9d24e82272b4/go.mod h1:tRJNPiyCQ0inRvYxbN9jk5I+vvW/OXSQhTDSoE431IQ=
+golang.org/x/tools v0.0.0-20180221164845-07fd8470d635/go.mod h1:n7NCudcB/nEzxVGmLbDWY5pfWTLqBcC2KZ6jyYvM4mQ=
+golang.org/x/tools v0.0.0-20190114222345-bf090417da8b/go.mod h1:n7NCudcB/nEzxVGmLbDWY5pfWTLqBcC2KZ6jyYvM4mQ=
+golang.org/x/tools v0.0.0-20190311212946-11955173bddd/go.mod h1:LCzVGOaR6xXOjkQ3onu1FJEFr0SW1gC7cKk1uF8kGRs=
+google.golang.org/appengine v1.1.0/go.mod h1:EbEs0AVv82hx2wNQdGPgUI5lhzA/G0D9YwlJXL52JkM=
+google.golang.org/genproto v0.0.0-20180817151627-c66870c02cf8/go.mod h1:JiN7NxoALGmiZfu7CAH4rXhgtRTLTxftemlI0sWmxmc=
+google.golang.org/grpc v1.19.0/go.mod h1:mqu4LbDTu4XGKhr4mRzUsmM4RtVoemTSY81AxZiDr8c=
+google.golang.org/grpc v1.21.0/go.mod h1:oYelfM1adQP15Ek0mdvEgi9Df8B9CZIaU1084ijfRaM=
+gopkg.in/alecthomas/kingpin.v2 v2.2.6/go.mod h1:FMv+mEhP44yOT+4EoQTLFTRgOQ1FBLkstjWtayDeSgw=
+gopkg.in/check.v1 v0.0.0-20161208181325-20d25e280405/go.mod h1:Co6ibVJAznAaIkqp8huTwlJQCZ016jof/cbN4VW5Yz0=
+gopkg.in/check.v1 v1.0.0-20180628173108-788fd7840127/go.mod h1:Co6ibVJAznAaIkqp8huTwlJQCZ016jof/cbN4VW5Yz0=
+gopkg.in/resty.v1 v1.12.0/go.mod h1:mDo4pnntr5jdWRML875a/NmxYqAlA73dVijT2AXvQQo=
+gopkg.in/yaml.v2 v2.0.0-20170812160011-eb3733d160e7/go.mod h1:JAlM8MvJe8wmxCU4Bli9HhUf9+ttbYbLASfIpnQbh74=
+gopkg.in/yaml.v2 v2.2.1/go.mod h1:hI93XBmqTisBFMUTm0b8Fm+jr3Dg1NNxqwp+5A1VGuI=
+gopkg.in/yaml.v2 v2.2.2/go.mod h1:hI93XBmqTisBFMUTm0b8Fm+jr3Dg1NNxqwp+5A1VGuI=
+honnef.co/go/tools v0.0.0-20190102054323-c2f93a96b099/go.mod h1:rf3lG4BRIbNafJWhAfAdb/ePZxsR/4RtNHQocxwk9r4=
diff --git a/ocd/cli/ealt/main.go b/ocd/cli/ealt/main.go
new file mode 100644 (file)
index 0000000..7060933
--- /dev/null
@@ -0,0 +1,23 @@
+/*
+ * Copyright 2020 Huawei Technologies Co., Ltd.
+ *
+ * Licensed under the Apache License, Version 2.0 (the "License");
+ * you may not use this file except in compliance with the License.
+ * You may obtain a copy of the License at
+ *
+ *     http://www.apache.org/licenses/LICENSE-2.0
+ *
+ * Unless required by applicable law or agreed to in writing, software
+ * distributed under the License is distributed on an "AS IS" BASIS,
+ * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+ * See the License for the specific language governing permissions and
+ * limitations under the License.
+ */
+package main
+
+import "ealt/cmd"
+
+func main() {
+       cmd.Execute()
+}